package es.kauron.jstudy.model;

import javafx.beans.property.BooleanProperty;
import javafx.beans.property.SimpleBooleanProperty;

import java.io.File;
import java.util.prefs.BackingStoreException;
import java.util.prefs.Preferences;

public class AppConfig {
    public static BooleanProperty repeatWrong, showFeedback, repeatImmediately;
    public static File lastDir;

    public static void save() {
        Preferences prefs = Preferences.userRoot();
        prefs.putBoolean("repeatWrong", repeatWrong.get());
        prefs.putBoolean("showFeedback", showFeedback.get());
        prefs.putBoolean("repeatImmediately", repeatImmediately.get());
        prefs.put("lastDir", lastDir == null ? "" : lastDir.getAbsolutePath());
        try {
            prefs.flush();
        } catch (BackingStoreException e) {
            e.printStackTrace();
        }
    }

    public static void load() {
        Preferences prefs = Preferences.userRoot();
        repeatWrong  = new SimpleBooleanProperty(prefs.getBoolean("repeatWrong", true));
        showFeedback = new SimpleBooleanProperty(prefs.getBoolean("showFeedback", true));
        repeatImmediately = new SimpleBooleanProperty(prefs.getBoolean("repeatImmediately", false));
        repeatWrong.addListener((obj, o, n) -> save());
        showFeedback.addListener((obj, o, n) -> save());
        repeatImmediately.addListener((obj, o, n) -> save());
        String dirPath = prefs.get("lastDir", "");
        if (!dirPath.isEmpty()) lastDir = new File(dirPath);
    }

    public static String printValues() {
        return String.format("repeatWrong=%b\nshowFeedback=%b", repeatWrong, showFeedback);
    }
}
